%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

Name:           mom
Version:        0.3.2
Release:        8%{?dist}
Summary:        Dynamically manage system resources on virtualization hosts

Group:          Applications/System
License:        GPLv2
URL:            http://wiki.github.com/aglitke/mom
Source0:        %{name}-%{version}.tar.gz

Patch0: 0001-Fix-ever-increasing-CPU-usage.patch
Patch1: 0002-KSM-Only-tune-when-there-are-changes-to-make.patch
Patch2: 0003-mom-Fix-balloon-libvirt-interface-exception.patch
Patch3: 0001-mom-Fix-KeyError-exception-while-qemu-guest-agent-er.patch
Patch4: 0002-mom-communicate-with-qemu-guest-agent-using-hypervis.patch
Patch5: 0003-Add-support-for-optional-collector-fields-and-null-e.patch
Patch6: 0004-Add-support-for-swap-information-to-be-used-in-polic.patch
Patch7: 0005-Make-the-policy-language-more-lisp-like.patch
Patch8: 0006-Add-tests-to-MANIFEST.in-and-run-them-during-an-rpm-.patch
Patch9: 0007-policy-Fix-balloon-policy-syntax-and-semantics.patch
Patch10: 0008-libvirtInterface-Convert-some-keys-of-mem_stats-in-g.patch
Patch11: 0009-GuestMemory-Start-memory-stats-collection-on-initial.patch
Patch12: 0001-Create-new-evaluator-for-each-evaluation-run.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
BuildRequires:  python-devel
BuildRequires:  python-nose
BuildRequires:  automake
BuildRequires:  autoconf

# MOM makes use of libvirt by way of the python bindings to monitor and
# interact with virtual machines.
Requires:       libvirt
Requires:       libvirt-python

%description
MOM is a policy-driven tool that can be used to manage overcommitment on KVM
hosts. Using libvirt, MOM keeps track of active virtual machines on a host. At
a regular collection interval, data is gathered about the host and guests. Data
can come from multiple sources (eg. the /proc interface, libvirt API calls, a
client program connected to a guest, etc). Once collected, the data is
organized for use by the policy evaluation engine. When started, MOM accepts a
user-supplied overcommitment policy. This policy is regularly evaluated using
the latest collected data. In response to certain conditions, the policy may
trigger reconfiguration of the system’s overcommitment mechanisms. Currently
MOM supports control of memory ballooning and KSM but the architecture is
designed to accommodate new mechanisms such as cgroups.



%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1

%build
echo "v%{version}-%{release}" > VERSION
autoreconf -if
%configure
make
%{__python} setup.py build

%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
install -Dp contrib/momd.init $RPM_BUILD_ROOT/%{_initrddir}/momd

cp $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}/examples/mom-balloon+ksm.conf \
   $RPM_BUILD_ROOT/%{_sysconfdir}/momd.conf

# Correct the installed location of documentation files
mv $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name} \
   $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}-%{version}
cp COPYING README $RPM_BUILD_ROOT/%{_defaultdocdir}/%{name}-%{version}


# Skip failing tests. Re-enable once fixed.
# %check
# nosetests tests/*.py

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ $1 = 0 ] ; then
    /sbin/service momd stop >/dev/null 2>&1
    /sbin/chkconfig --del momd
fi

%postun
if [ "$1" -ge "1" ] ; then
    /sbin/service momd condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%{_sbindir}/momd
%{_initrddir}/momd
%{python_sitelib}/*
%config(noreplace) %{_sysconfdir}/momd.conf

# The use of '_defaultdocdir' conflicts with 'doc'. Therefore, 'doc' MUST NOT
# be used to include additional documentation files so long as this is in use.
%{_defaultdocdir}/%{name}-%{version}/

%changelog
* Tue Nov 26 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-8
- Use new evaluator (with new variable stack) for each policy
  run.
  Resolves: rhbz#1025845

* Fri Nov 22 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-7
- Fix KeyError exception while qemu-guest-agent error handling
- communicate with qemu-guest-agent using hypervisor_iface via libvirt
- Add support for optional collector fields and (null expr) test
  Related: rhbz#1025845
- Add support for swap information to be used in policy
  Related: rhbz#1025845
- Make the policy language more lisp like
- Add tests to MANIFEST.in and run them during an rpm build
- Fix balloon policy syntax and semantics
  Resolves: rhbz#1025845
- Convert some keys of mem_stats in getVmMemoryStats()
- Start memory stats collection on initialization

* Thu Aug 22 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-6
- Fix ever increasing CPU usage
  Resolves: rhbz#999973

* Wed Aug 21 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-5
- Fix the changelog
  Related: rhbz#822623

* Wed Aug 21 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-4
- Include upstream fixes for KSM and libvirt
  Related: rhbz#967562

* Wed Jul 31 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-3
- Accept ballon info in string form
  Related: rhbz#974917

* Thu Jul 18 2013 Martin Sivak <msivak@redhat.com> - 0.3.2-1
- Update to keep the API in sync with VDSM
  Related: rhbz#822623

* Tue Jul 16 2013 Martin Sivak <msivak@redhat.com> - 0.3.1.1-1
- Upstream merged the patches we had
  Related: rhbz#822623

* Mon Jul 15 2013 Martin Sivak <msivak@redhat.com> - 0.3.1-1
- Initial package import
  Resolves: rhbz#822623
  Related: rhbz#967572
  Related: rhbz#967574
